VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Node"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Klasse Node ('Knoten', 'Shop', 'Station')
' Alfred Ruf 04.05.2011

Private m_Name As String ' BSP: "Home Sweet Home", "Tante Ernas Kleintierhof"

' Parent
Private m_CAT As Category

' Koordinaten
Private m_XPos As Single
Private m_YPos As Single

' Lnge des krzesten Pfades zu Me
Private m_MinPath As Single

' vorangehender Node des krzesten Pfades zu Me
Private m_NODPrev As Node
Friend Property Get CAT() As Category
    Set CAT = m_CAT
End Property
Friend Property Get MinPath() As Single
    MinPath = m_MinPath
End Property
Friend Property Get NODPrev() As Node
    Set NODPrev = m_NODPrev
End Property
Friend Property Get Name() As String
    Name = m_Name
End Property
Friend Function Init(ByVal sNodeDef As String, CAT_ As Category) As Boolean
    Dim Pos As Integer
    Dim sPos As String
    Dim Stris() As String
    
    Set m_CAT = CAT_
    
    sNodeDef = Trim$(sNodeDef)
    
    Pos = InStr(2, sNodeDef, "->")
    
    If 2 <= Pos Then
        ' Name auslesen
        m_Name = RTrim$(Left$(sNodeDef, Pos - 1))
        
        ' Position auslesen
        sPos = LTrim$(Mid$(sNodeDef, Pos + 2))
        If sPos Like "(*|*)" Then
            sPos = Mid$(sPos, 2, Len(sPos) - 2)
            sPos = Replace(sPos, ",", ".")      ' Dezimalkomma bereinigen
            Stris = Split(sPos, "|")
            If UBound(Stris) = 1 Then
                If IsNumeric(Stris(0)) Then
                    m_XPos = CSng(Stris(0))
                    If IsNumeric(Stris(1)) Then
                        m_YPos = CSng(Stris(1))
                        Init = True
                    End If
                End If
            End If
        End If
    End If
End Function
Friend Sub SearchShortestPath()
    
    ' m_MinPath ermitteln
    
    Dim CurPath As Single
    Dim NOD As Node
    
    m_MinPath = c_MaxSingle
    
    ' Me: aktueller Node
    
    For Each NOD In GL_PrevNodeColl
        CurPath = NOD.IncPath2(m_XPos, m_YPos)
        If CurPath < m_MinPath Then
            m_MinPath = CurPath
            Set m_NODPrev = NOD
        End If
        ' Pfade gleicher Lnge werden ignoriert!
    Next
End Sub
Friend Function IncPath2(XPos2 As Single, YPos2 As Single) As Single
    ' Addition der Distanz [Me <-> aktueller Node] zum krzesten Pfad
    IncPath2 = Sqr((m_XPos - XPos2) * (m_XPos - XPos2) + (m_YPos - YPos2) * (m_YPos - YPos2)) + m_MinPath
End Function
Friend Sub CreatePathInfo()
    
    ' Me: Endknoten des krzesten Pfades
    
    Dim Text As String
    Dim NOD As Node
    Dim OnceHit As Boolean
        
    ' Pfad als String generieren
    Set NOD = Me
    Do
        Text = NOD.Name & Text
        If NOD.CAT.IsStartCategory And OnceHit Then
            Exit Do
        End If
        Text = " -> " & Text
        OnceHit = True
        Set NOD = NOD.NODPrev
    Loop
    
    ' File-Output gemss Aufgabenstellung
    WriteFile sFileOutput, Text
    
    ' weitere Informationen fr Print/MsgBox-Output hinzufgen
    Text = Text & vbNewLine & vbNewLine
    
    Text = Text & "Lnge: " & CStr(m_MinPath) & vbNewLine & vbNewLine
    
    Text = Text & "Rechenzeit: " & STW.GetTime & "  (" & RunMode & ")" & vbNewLine & vbNewLine
    
    Text = Text & "Input-File Reihenfolge: " & sFileTask & vbNewLine
    Text = Text & "Input-File Stationen: " & sFileStations & vbNewLine
    Text = Text & "Output-File: " & sFileOutput
    
    If IsDesign Then
        Debug.Print
        Debug.Print "#### " & EXEInfo & " ####"
        Debug.Print
        Debug.Print Text
        Debug.Print
        Beep
    Else
        MsgBox Text, vbOKOnly, EXEInfo
    End If
End Sub
Private Property Get EXEInfo() As String
    EXEInfo = App.EXEName & " - Krzester Weg - Nautilo"
End Property
Private Property Get RunMode() As String
    If IsDesign Then
        RunMode = "Design Modus"
    Else
        RunMode = "EXE Modus"
    End If
End Property
Private Property Get IsDesign() As Boolean
    ' Debug.Assert-Zeile wird nur im Entwurf (VBA oder VB) abgearbeitet
    Dim Bool As Boolean
    Debug.Assert TurnTrue(Bool)
    IsDesign = Bool
End Property
Private Function TurnTrue(Bool As Boolean) As Boolean
    Bool = True
    TurnTrue = True
End Function

