Attribute VB_Name = "modFile"
Option Explicit

' Modul modFile (Input/Output)
' Alfred Ruf 04.05.2011

Private Declare Function MultiByteToWideChar Lib "kernel32.dll" ( _
                         ByVal CodePage As Long, _
                         ByVal dwFlags As Long, _
                         ByVal lpMultiByteStr As Long, _
                         ByVal cbMultiByte As Long, _
                         ByVal lpWideCharStr As Long, _
                         ByVal cchWideChar As Long) As Long
                         
Private Const CP_UTF8 As Long = 65001

Private Function ConvertFromUTF8(ByRef bytArr() As Byte) As String
    Dim Size As Long
    Dim Pointer As Long
    Dim Length As Long
    Dim Buffer As String
    Dim StartPos As Long
    Dim BOMFound As Boolean
    
    StartPos = 0
    Size = UBound(bytArr) + 1
    
    ' einleitende BOM (Byte Order Mark) Sequenzen "﻿" berspringen
    Do
        BOMFound = False
        
        If Size < StartPos Then
            Exit Function
        End If
        
        If bytArr(StartPos) = &HEF Then
            If bytArr(StartPos + 1) = &HBB Then
                If bytArr(StartPos + 2) = &HBF Then
                    Size = Size - 3
                    StartPos = StartPos + 3
                    BOMFound = True
                End If
            End If
        End If
    Loop Until Not BOMFound
    
    Pointer = VarPtr(bytArr(StartPos))
    Length = MultiByteToWideChar(CP_UTF8, 0, Pointer, Size, 0, 0)
    Buffer = Space$(Length)
    MultiByteToWideChar CP_UTF8, 0, Pointer, Size, StrPtr(Buffer), Length
    ConvertFromUTF8 = Buffer
    
End Function
Public Function ReadUTF8File(ByVal sFile As String, sContent As String) As Boolean
    Dim Fi As Integer
    Dim bytArr() As Byte
    Dim FullPath As String
    
    On Error GoTo ErrorHandler
    
    FullPath = App.Path & "\" & sFile
    
    If Dir(FullPath) = "" Then
        RaiseError "File """ & sFile & """ existiert nicht."
        Exit Function
    End If
    
    Fi = FreeFile
    Open FullPath For Binary Access Read As Fi
    
    If LOF(Fi) = 0 Then
        RaiseError "Leeres File """ & sFile & """"
        Close Fi
    Else
        ReDim bytArr(LOF(Fi) - 1)
        Get Fi, , bytArr
        Close Fi
        
        sContent = ConvertFromUTF8(bytArr)
        
        If Left$(ReadUTF8File, 2) = "??" Then
            ' Annahme: keine UTF8, sondern ANSI Codierung
            sContent = CStr(bytArr)
        End If
        
        If sContent = "" Then
            RaiseError "Leeres File """ & sFile & """"
        Else
            ReadUTF8File = True
        End If
        
    End If
    
    Exit Function
ErrorHandler:
    RaiseError "Fehler in ReadUTF8File """ & sFile & """" & vbNewLine & Err.Description
End Function
Public Sub WriteFile(ByVal sFile As String, sContent As String)
    Dim Fi As Integer
    Dim FullPath As String
    
    On Error GoTo ErrorHandler
    
    FullPath = App.Path & "\" & sFile
    
    If Dir(FullPath) <> "" Then
        Kill FullPath
    End If
    
    Fi = FreeFile
    Open FullPath For Binary As Fi
    Put Fi, , sContent
    Close Fi
    
    Exit Sub
ErrorHandler:
    RaiseError "Fehler in WriteFile """ & sFile & """" & vbNewLine & Err.Description
End Sub

